#include "cgheader.h"

int anzahlcheater=0, verschcheater=0, gesamttage=0, monate[13], tage[13], logs; //muss global fuer die statistik sein;
string s_version="1.35",s_datum="26.7.02", wert;
bool htmlexist=false;
int cmp[]={106, 111, 111, 32, 99, 97, 110, 32, 112, 117, 116, 32, 119, 101, 101, 100, 32, 105, 110, 32, 104, 101, 114, 101};
int commentcount[]={42, 32, 71, 114, 69, 101, 84, 122, 32};
int commnext[]={70, 114, 111, 77, 32, 58, 11};
int commend[]={32, 84, 72, 67, 43, 43, 32, 103, 114, 48, 48, 112, 13};
 
// Variablen fuer Hashing
int gefundeneWonID=0;
int *hash, hashgr=1;
	
cfgvalues *pcfg=new cfgvalues;  //genau eins davon, keine Verkettung
cheater *start=new cheater; //verkettete Cheaterliste
cheater *lauf=start; //fuer die Ausgabe der Cheaterliste

void hash_erstellen()
{
	int i;
	//primzahlen fuer Hashgroesse
	int prim[]={ 151, 307, 617, 1237, 2477, 4957, 9923, 20023, 40063, 80141, 160481,
		     321311, 642737, 1285511, 2571071, 5142197, 10806377};

	//fuer doppelte hashgr naechste primzahl suchen		     
	for( i=0; prim[i] <= ( 2 * (hashgr) ); i++);
  
	hashgr=prim[i];
	//speicher fuer den hash allokieren;
	hash=new int[hashgr];
	
	if( pcfg->debug)
	{	
		if( hash == NULL )
			cout<<" -DEBUG- Hash konnte nicht allokiert!";
		else
			cout<<" -DEBUG- Hash wird erstellt...";
	}
	
	//initialisierung des Hashs
	for( i = 0; i<hashgr; i++)
	    hash[i]=0; //wonid vorbesetzen
}

int hash_key(int wonid) //erstmal keine aufwendige schluesselfunktion
{
	int key;
	key=wonid%hashgr; 
	return key;
}

int hash_einfuegen(int wonid, int stelle)
{		
	if( hash[stelle]== 0 )
     //wenn die stelle noch unbesetzt, dann eintragen und melden (return 0)
	{
		hash[stelle]=wonid;
		if(pcfg->debug)
		    cout << " -DEBUG- <abgelegt>";
		
		gefundeneWonID++;
		return 0;
	}
	else if( hash[stelle] == wonid )
     //wenn wonid schon im hash, bescheidt sagen (return 1)
	{
		if(pcfg->debug)
		    cout << " -DEBUG- <doppelt>";
		
		return 1;
	}
	else if( hash[stelle] != wonid )
     //wenn schon andere wonid an der stelle, bescheidt sagen (return 2)
	{
		if(pcfg->debug)
			cout << " -DEBUG- <kollision>";
	
		return 2;
	}
	return 4;
}

void hash_in(string won)
{
	int i;
	int key, wonid,eingefuegt=2;
	char wonchar[10];
	// fuer rehash, rehash := ringtausch 
	int *oldhash=NULL, oldhashgr=0;
	
	if(hash==NULL)
	{
	    hash_erstellen();
	}
	
	//string won in int wonid wandeln
	for(i=0; i<won.length(); i++)
	{
	    wonchar[i]=won[i];
	}
	wonchar[i]='\0';
	wonid=atoi(wonchar);
	
	//hash-key erzeugen
	key=hash_key(wonid);
	
	if(pcfg->debug)
	{
	    cout<<endl<< " -DEBUG- Hashgroesse: "<<(hashgr)
	        <<" WonID: "<<wonid
		<<" HashKey: "<<key<<endl;
	}

	while(eingefuegt == 2)
	{
		eingefuegt=hash_einfuegen(wonid, key);
		key=(key+1)%(hashgr);
	}

	 // bei 80% fuellung des hashs, ist ein rehash faellig
	if( gefundeneWonID >= (hashgr * 80 / 100) )
	{
		if(pcfg->debug)
		    cout<<endl<<"--->Re-Hashing..."<<endl;   
		oldhashgr=hashgr;
		oldhash=hash;
		hash=NULL;
		hash_erstellen();
		
		for(i=0; i < oldhashgr; i++)
		{
			if(oldhash[i] != 0)
			{
				key=hash_key(oldhash[i]);
				eingefuegt=2;
				while(eingefuegt == 2)
				{
					eingefuegt=hash_einfuegen(oldhash[i], key);
					key=(key+1)%(hashgr);
				}
			}
		}
		delete [] oldhash;
	}
}

void statistik()  //Statistikausgabe
{
     cout<<endl<<" -> "<<pcfg->servername<<" Cheaterstatistik:"<<endl
    <<" --> von "<<gefundeneWonID<<" versch. Spielern haben "<<verschcheater<<" gecheatet ("<<(double)verschcheater / (double)gefundeneWonID * 100.0<<" %)"<<endl;
    cout <<" --> "<<(double)verschcheater/(double)gesamttage<<" Cheater pro Tag"<<endl;
}

void htmlcopy()
{
	char *pfadzeiger=&(pcfg->htmlpfad[0]); //Zeiger auf den HTMLPfad
	string von="../cgban.htm"; 
	string nach=pfadzeiger;
	
	ifstream in(von.c_str(), ios::binary);
   	if (in)
      		{
     		ofstream out(nach.c_str(), ios::binary, ios::trunc);
     		if (out) {out << in.rdbuf();}
		out.close();
		}
	in.close();
}

void banfile()
{
	cheater *bancursor=start;
	ofstream banfile("../cgban.cfg", ios::trunc);	//zu schreibende Datei
	short banfilehelp=0;
	while (banfilehelp < verschcheater) //verkettete Liste durchgehen und in die ban schreiben
	{
		banfile <<"//" <<bancursor->c_datetime<<" - Nickname: " <<bancursor->c_name<<" - Logname: "<<bancursor->c_logname<<endl;
		banfile <<"banid 0.0 "<<bancursor->c_wonid<<endl<<endl;
		bancursor=bancursor->next; //naechstes Element der Liste
		banfilehelp++;
	}
	banfile.close();
}

void htmfile()
{
	cheater *htmcursor=start;
	ofstream htm("../cgban.htm"); 
	short htmfilehelp=0;

	htm <<"<html> "<<endl;
	htm <<"<head> "<<endl;
	htm <<"<title>"<<pcfg->htmltitel<<"</title>"<<endl;
	htm <<"</head>"<<endl;
	htm <<"<body bgcolor="<<pcfg->htmlhgfarbe<<" text="<<pcfg->htmlschriftfarbe<<" vlink="<<pcfg->linkfarbe<<" alink="<<pcfg->linkfarbe<<">"<<endl;
	htm <<"<h1 align=center>ValveAC Cheaterliste</h1>"<<endl;
	htm <<"<br>"<<endl<<"<br>"<<endl;
	htm <<"<table width=75% border="<<pcfg->tabellenstaerke<<" align=center bordercolor="<<pcfg->tabellenfarbe<<" bgcolor="<<pcfg->tabellenhgfarbe<<">"<<endl;
	htm <<"<tr>"<<endl<<"<td>"<<endl<<"<div align=center><font size="<<pcfg->topschrift<<"> <b>Datum</b></font></div>"<<endl<<"</td>"<<endl;
	htm <<"<td>"<<endl<<"<div align=center><font size="<<pcfg->topschrift<<"> <b>Nick</b></font></div>"<<endl<<"</td>"<<endl;
	htm <<"<td>"<<endl<<"<div align=center><font size="<<pcfg->topschrift<<"> <b>Wonid</b></font></div>"<<endl<<"</td>"<<endl;
	htm <<"<td>"<<endl<<"<div align=center><font size="<<pcfg->topschrift<<"> <b>Logname</b></font></div>"<<endl<<"</td>"<<endl<<"</tr>"<<endl;

	while (htmfilehelp < verschcheater)  //Ein Durchlauf=Eine Cheaterzeile
	{
		htm <<endl<<"<tr>"<<endl<<"<td>";
		if (pcfg->schriftfett)
			htm<<"<b> ";

		htm<<"<div align=center> <font size="<<pcfg->schriftgroesse<<">"<<htmcursor->c_datetime<<"</font></div>";
		if (pcfg->schriftfett)
			htm<<" </b>";
	
		htm<<" </td>"<<endl;
		htm<<"<td>";
		if (pcfg->schriftfett)
			htm<<"<b> ";

		htm<<"<div align=center> <font size="<<pcfg->schriftgroesse<<">"<<htmcursor->c_name<<"</font></div>";
		if (pcfg->schriftfett)
			htm<<" </b>";
	
		htm<<" </td>"<<endl;
		htm<<"<td>";
		if (pcfg->schriftfett)
			htm<<"<b> ";
	
		htm<<"<div align=center> <font size="<<pcfg->schriftgroesse<<">"<<htmcursor->c_wonid<<"</font></div>";
		if (pcfg->schriftfett)
			htm<<" </b>";
	
		htm<<" </td>"<<endl;
		htm<<"<td>";
		if (pcfg->schriftfett)
			htm<<"<b> ";
	
		htm<<"<div align=center> <font size="<<pcfg->schriftgroesse<<">"<<htmcursor->c_logname<<"</font></div>";
		if (pcfg->schriftfett)
			htm<<" </b>";
	
		htm<<" </td>"<<endl<<"</tr>"<<endl;
		htmfilehelp++;
		htmcursor=htmcursor->next;	
	}
	htm <<"</table>"<<endl;
	htm <<"<br>"<<endl<<"<br>"<<endl;

	//Infoblock
	htm <<"<table width=50% border="<<pcfg->tabellenstaerke<<" align=center bordercolor="<<pcfg->tabellenfarbe<<" bgcolor="<<pcfg->tabellenhgfarbe<<">"<<endl;
	htm <<"<tr>"<<endl<<"<td>"<<endl<<"<div align=center> <font size="<<pcfg->topschrift<<"> <b>Servername</b></font></div>"<<endl<<"</td>"<<endl;
	htm <<"<td>"<<endl<<"<div align=center> <font size="<<pcfg->topschrift<<"> <b>Serverip</b></font></div>"<<endl<<"</td>"<<endl;
	htm <<"<td>"<<endl<<"<div align=center> <font size="<<pcfg->topschrift<<"> <b>Cheater</b></font></div>"<<endl<<"</td>"<<endl<<"</tr>"<<endl;
	htm <<"<tr>"<<endl<<"<td>"<<endl<<"<div align=center> <font size="<<pcfg->schriftgroesse<<"> <b>"<<pcfg->servername<<"</b></font></div>"<<endl<<"</td>"<<endl;
	htm <<"<td>"<<endl<<"<div align=center> <font size="<<pcfg->schriftgroesse<<"> <b>"<<pcfg->serverip<<"</b></font></div>"<<endl<<"</td>"<<endl;
	htm <<"<td>"<<endl<<"<div align=center> <font size="<<pcfg->schriftgroesse<<"> <b>"<<verschcheater<<"</b></font></div>"<<endl<<"</td>"<<endl<<"</tr>"<<endl;
	htm<<"</table>"<<endl;
	
	//Statistiksblock
	if (pcfg->statistik)
	{
	htm <<"<br> <br>"<<endl;
	htm <<"<table width=50% border="<<pcfg->tabellenstaerke<<" align=center bordercolor="<<pcfg->tabellenfarbe<<" bgcolor="<<pcfg->tabellenhgfarbe<<">"<<endl;
		
	htm <<"<tr>"<<endl;
	htm <<"<td> <div align=center> <font size="<<pcfg->schriftgroesse<<"> <b> Anzahl Tage </b></font></div> </td>"<<endl;
	htm <<"<td> <div align=center> <font size="<<pcfg->schriftgroesse<<"> <b>"<<gesamttage<<"</b></font></div> </td>"<<endl;
	htm<<"</tr>"<<endl;
	
	htm <<"<tr>"<<endl;
	htm <<"<td> <div align=center> <font size="<<pcfg->schriftgroesse<<"> <b> Anzahl Logs </b></font></div> </td>"<<endl;
	htm <<"<td> <div align=center> <font size="<<pcfg->schriftgroesse<<"> <b>"<<logs<<"</b></font></div> </td>"<<endl;
	htm<<"</tr>"<<endl;
	
	htm <<"<tr>"<<endl;
	htm <<"<td> <div align=center> <font size="<<pcfg->schriftgroesse<<"> <b> Secure Violations </b></font></div> </td>"<<endl;
	htm <<"<td> <div align=center> <font size="<<pcfg->schriftgroesse<<"> <b>"<<anzahlcheater<<"</b></font></div> </td>"<<endl;
	htm<<"</tr>"<<endl;
	
	htm <<"<tr>"<<endl;
	htm <<"<td> <div align=center> <font size="<<pcfg->schriftgroesse<<"> <b> versch. Spieler / Cheater </b></font></div>"<<endl<<"</td>"<<endl;
	htm <<"<td> <div align=center> <font size="<<pcfg->schriftgroesse<<"> <b>"<<gefundeneWonID<<" / "<<verschcheater<<"</b></font></div> </td>"<<endl;
	htm<<"</tr>"<<endl;
	
	htm <<"<tr>"<<endl;
	htm <<"<td> <div align=center> <font size="<<pcfg->schriftgroesse<<"> <b> Cheater / Tag </b></font></div> </td>"<<endl;
	htm <<"<td> <div align=center> <font size="<<pcfg->schriftgroesse<<"> <b>"<<(double)verschcheater/(double)gesamttage<<"</b></font></div> </td>"<<endl;
	htm<<"</tr>"<<endl;
	
	htm <<"<tr>"<<endl;
	htm <<"<td> <div align=center> <font size="<<pcfg->schriftgroesse<<"> <b> Cheatergehalt </b></font></div> </td>"<<endl;
	htm <<"<td> <div align=center> <font size="<<pcfg->schriftgroesse<<"> <b>"<<(double)verschcheater/(double)gefundeneWonID*100<<"% </b></font></div> </td>"<<endl;
	htm<<"</tr>"<<endl;
		
	htm<<"</table>"<<endl;
	}
	htm <<"<p align=center><font size=2><b>erstellt mit <a href=http://alderaan.knatterton.de/cgrep/ target=_blank>CheaterGrep</a> Version "<<s_version<<"</b></font></p>"<<endl;
	htm <<"</body>"<<endl;
	htm <<"</html>"<<endl;
	htm.close();
}

int nextserverfind(int diesecureposi, char *dernamedeslogs) //bekommt Lognamen, duchsucht Log nach Cheatern
{
	ifstream serverinput(dernamedeslogs); //aktuelles log uebergeben, fnnen und testen ob erfolgreich
	unsigned short gefunden=0;
	unsigned int serverposition=0;
	serverinput.seekg(diesecureposi+50, ios::beg);	
	
	while (serverinput && gefunden==0)
	{
		string tempstring;
		serverinput >> tempstring;
		if (tempstring=="server.") //Suchstring CS 1.5
		{
			serverposition=serverinput.tellg();
			gefunden=1;								
		}
		else if (tempstring=="(code") //Suchstring CS 1.4
		{
			serverposition=serverinput.tellg();
			serverposition=serverposition-5; //wegen dem Code 0, Posi entsprechend anpassen
			gefunden=1;								
		}
	}
	serverinput.close();
	return serverposition;
}

void comment_erase(string comment)
{
	unsigned short j;
	for (short i=0;i<24;i++)
	{
		if (cmp[i]!=comment[i] ) {i=42;}
		if (i==23)
			{	
			cout<<endl<<endl;
			ERASE (j=0;j<=8;j++){char commtemp=commentcount[j];cout<<commtemp;}
			ERASE (j=0;j<=6;j++){char charcomm=commnext[j];cout<<charcomm;}
			ERASE (j=0;j<=12;j++){char header=commend[j];cout<<header;}
			cout<<endl<<endl;
			}
	}
}	

bool woninlist(string checkwonid)  //gibbet den Cheater schon ? (nach WONID)
{
	cheater* cursor=start;
	while (cursor->next != 0)
		{
		if (cursor->c_wonid==checkwonid) {return true;break;} //ok das reicht
		cursor=cursor->next;
		}
	return false;
}
	
void securecopy(int gefundeneposi, char *derlogname, int dieserverposi)
{
	int wonposihelp=dieserverposi-55;
	ifstream loginput(derlogname); //uebergebenes log oefnnen
	char tempstream;
	
	int gotoposi=gefundeneposi;
	
	char wonhelp; //WON nach der Secureposi in struct grabben
	loginput.seekg(wonposihelp, ios::beg);
	while (loginput.get(wonhelp) && wonhelp !='<')
	{
		wonposihelp=wonposihelp-1;
		loginput.seekg(wonposihelp, ios::beg);
	}
	
	while (loginput.get(tempstream) && tempstream !='>') 
	{
		lauf->c_wonid+=tempstream;
	}
		
if (woninlist(lauf->c_wonid))
	{  //falls WON existiert, Ausgabe nur im Debug Mode
	if (pcfg->debug){cout <<endl<<"-> WONID bereits vorhanden, ignoriere "<<lauf->c_wonid;}
	lauf->c_wonid="";
	}

else   //falls sie noch nich existiert, neuen cheater anlegen, werte rein usw.
{	verschcheater++;  //anzahlcheater is schon ++, jetzt auch verschcheater (da WON noch nich vorhanden)
	wonposihelp=wonposihelp-2;
	loginput.seekg(wonposihelp, ios::beg);
	
	while (loginput.get(wonhelp) && wonhelp !='<')
	{
		wonposihelp=wonposihelp-1;
		loginput.seekg(wonposihelp, ios::beg);
	}
	wonposihelp=wonposihelp+1;
	loginput.seekg(gotoposi+2, ios::beg); //Cheatername in struct, dank Wonposi safe
	while (loginput.get(tempstream) && loginput.tellg() < wonposihelp) 
	{
		lauf->c_name+=tempstream;
	}
	
	loginput.seekg(gefundeneposi-30, ios::beg); //Datum-Zeit ins struct
	short datehelp =0;
	while (loginput.get(tempstream) && datehelp<21) 
	{
		lauf->c_datetime+=tempstream;
		datehelp++;
	}
	lauf->c_logposi=gefundeneposi;
	lauf->c_logname=derlogname;
	lauf->next=new cheater;
	lauf=lauf->next;
	lauf->next=0;
	loginput.close();
}//else	Ende
}

void loadvalues()
{
	//pcfg->debug=false; // erstmal ein paar defaults
	pcfg->schriftfett=true; 
	ifstream cfgf("../cgconfig.txt");
	
	while (getline(cfgf, wert))
	{
		if ( wert.length() == 0) //erstmal Leerzeilen ueberspringen
		{
			continue;
		}
		else if ( (wert.at(0)) == '#') 
		{
			wert.erase(0,2);
			comment_erase(wert);
			continue;
		}
		else if ( (wert.find("htmlpfad")) != -1)
		{
			wert.erase(0,9); 
			short pfadlaenge=wert.length(); //Pfadlaenge fr den / check am ende
			if (wert[0]=='/' && wert[pfadlaenge-1]=='/')  //Slashes korrekt im Pfadnamen?
	 		{
	 			pcfg->htmlpfad=wert+"cgban.htm";
	 			htmlexist=true;
	 		}
			pcfg->htmltitel=wert;
			if (pcfg->debug) {cout <<" -DEBUG- -> Htmlpfad : "<<wert<<endl;}
		}
		else if ( (wert.find("htmltitel")) != -1)
		{
			wert.erase(0,10);
			pcfg->htmltitel=wert;
			if (pcfg->debug) cout <<" -DEBUG- -> Htmltitel : "<<wert<<endl;
		}
		else if ( (wert.find("htmlhgfarbe")) != -1)
		{
			wert.erase(0,12);
			pcfg->htmlhgfarbe=wert;
			if (pcfg->debug) cout <<" -DEBUG- -> Htmlhgfarbe : "<<wert<<endl;
		}
		else if ( (wert.find("htmlschriftfarbe")) != -1)
		{
			wert.erase(0,17);
			pcfg->htmlschriftfarbe=wert;
			if (pcfg->debug) cout <<" -DEBUG- -> Htmlschriftfarbe : "<<wert<<endl;
		}
		else if ( (wert.find("tabellenfarbe")) != -1)
		{
			wert.erase(0,14);
			pcfg->tabellenfarbe=wert;
			if (pcfg->debug) cout <<" -DEBUG- -> Tabellenfarbe : "<<wert<<endl;
		}
		else if ( (wert.find("tabellenhgfarbe")) != -1)
		{
			wert.erase(0,16);
			pcfg->tabellenhgfarbe=wert;
			if (pcfg->debug) cout <<" -DEBUG- -> Tabellenhgfarbe : "<<wert<<endl;
		}
		else if ((wert.find("tabellenstaerke")) !=-1)
		{
			wert.erase(0,16);
			pcfg->tabellenstaerke=wert;
			if (pcfg->debug) cout <<" -DEBUG- -> Tabellenstaerke : "<<wert<<endl;
		}
		else if ((wert.find("schriftfett")) != -1)
		{
			wert.erase(0,12);
			if(wert=="ja" || wert=="Ja" || wert=="JA")
			    pcfg->schriftfett=true;
			else
			    pcfg->schriftfett=false;
			if (pcfg->debug) cout <<" -DEBUG- -> Schriftfett : "<<wert<<endl;
		}
		else if ((wert.find("schriftgroesse")) != -1)
		{
			wert.erase(0,15);
			pcfg->schriftgroesse=wert;
			if (pcfg->debug) cout <<" -DEBUG- -> Schriftgroesse : "<<wert<<endl;
		}
		else if ((wert.find("topschrift")) != -1)
		{
			wert.erase(0,11);
			pcfg->topschrift=wert;
			if (pcfg->debug) cout <<" -DEBUG- -> Topschriftgroesse : "<<wert<<endl;
		}
		else if ((wert.find("linkfarbe")) != -1)
		{
			wert.erase(0,10);
			pcfg->linkfarbe=wert;
			if (pcfg->debug) cout <<" -DEBUG- -> Linkfarbe : "<<wert<<endl;
		}
		else if ((wert.find("serverip")) != -1)
		{
			wert.erase(0,9);
			pcfg->serverip=wert;
			if (pcfg->debug) cout <<" -DEBUG- -> Serverip : "<<wert<<endl;
		}
		else if ((wert.find("servername")) != -1)
		{
			wert.erase(0,11);
			pcfg->servername=wert;
			if (pcfg->debug) cout <<" -DEBUG- -> Servername : "<<wert<<endl;
		}
		else if ((wert.find("statistik")) != -1)
		{
			wert.erase(0,10);
			if(wert=="nein" || wert=="Nein" || wert=="NEIN")
			    pcfg->statistik=false;
			    
			if (pcfg->debug) cout <<" -DEBUG- -> Statistik : "<<wert<<endl;
		}
	
	} //while Ende, neachster string einlesen und weiter gehts
	cfgf.close();
}

void securesearch(char *namedeslogs) //bekommt Lognamen, duchsucht dieses Log nach Cheatern
{
	ifstream loginput(namedeslogs); //aktuelles Log oefnnen
	unsigned int secureposi=0;
	int serverposi, wonlaenge=0;
		
	while (loginput) //Log durchgehen, mit suchstring vergleichen
	{
		string tempstring;
		loginput >> tempstring;
		if (tempstring=="Secure:") //Cheater gefunden
		{
			secureposi=loginput.tellg();
			anzahlcheater++;
			serverposi=nextserverfind(secureposi, namedeslogs);  //sucht den passenden Endstring nach "Secure", bei CS 1.4 != Cs 1.5 !!!
			securecopy(secureposi, namedeslogs, serverposi); //kopiert den passenden string			
		}
		else if (pcfg->statistik==true && tempstring=="connected,")
		{
			string wonid;
			char wonhelp;
			serverposi=loginput.tellg();
			ifstream logwonid(namedeslogs);
			
			serverposi=serverposi-17;
			logwonid.seekg(serverposi, ios::beg);	
		
			logwonid.get(wonhelp);
			while (wonhelp != '<')
			{
				serverposi--;
				logwonid.seekg(serverposi, ios::beg);
				logwonid.get(wonhelp);
			}
			serverposi++;
			logwonid.get(wonhelp);
			while(wonhelp != '>')
			{
				wonid += wonhelp;		
				serverposi++;
				logwonid.seekg(serverposi, ios::beg);
				logwonid.get(wonhelp);
			}
			hash_in(wonid);
			wonid="";
		}

	} //durchs Log durch ...
	loginput.close();
}

void logcheck()
{
	short monat, tag, hunderter, zehner, einer,  gekuerzt; //breakit=nach breakit nicht gefundenen logs, naechster tag (break)
	short breakit=0;
	bool auswertung=false;
	
	char log[]="Lmmttccc.log";
	char *dateiname=log;  //Zeiger auf Dateinamen, funktionsmaessig ubergebbar
	
	for( monat=1; monat<=12; monat++)
	{
		cout << setiosflags(ios::unitbuf);
		
		switch( monat )
		{	
			case 1: cout << " -> Scanne Januar ..."; break;   
			case 2: cout << " -> Scanne Februar ..."; break; 		
 			case 3: cout << " -> Scanne Maerz ..."; break;
 			case 4: cout << " -> Scanne April ..."; break;
 			case 5: cout << " -> Scanne Mai ..."; break;
 			case 6: cout << " -> Scanne Juni ..."; break;
 			case 7: cout << " -> Scanne Juli ..."; break;
 			case 8: cout << " -> Scanne August ..."; break;
 			case 9: cout << " -> Scanne September ..."; break;
 			case 10: cout << " -> Scanne Oktober ..."; break;
 			case 11: cout << " -> Scanne November ..."; break;
 			case 12: cout << " -> Scanne Dezember ..."; break;
 		}	
 		
 		if (monat<=9) 
 		{
 			log[1]=48;
 			log[2]=monat+48; //Charfeld=L0...
 		}
 		else
 		{ 
 			log[1]=49; 	
 			log[2]=(monat%10)+48; //aus 12 wird 2, charfeld=L00... L09...L10...L11..
		}	
		
		for( tag=1; tag<=31; tag++)
		{
			if (tag<10) {log[3]=48;}
			else if (tag >=10 && tag<20) {log[3]=49;}
			else if (tag >=20 && tag<30) {log[3]=50;}
			else {log[3]=51;}
			gekuerzt=tag%10; //letzte Tagstelle
			log[4]=gekuerzt+48;
			breakit=0;
			
			for( hunderter=0; hunderter<=9; hunderter++)
			{
				log[5]=hunderter+48;
			
				for( zehner=0; zehner<=9; zehner++)
				{
					log[6]=zehner+48;
				
					for( einer=0; einer<=9; einer++)
					{
						log[7]=einer+48;
						ifstream dateiexist(dateiname);
						if (!dateiexist)
						{
							breakit++;
							break;
						}
						else 	
						{
							securesearch(dateiname); //aktuelles Log existiert, durchparsen!
							logs++; //aktuelles Log existiert: Logs-Gesamt hochgezaehlt
							monate[monat]++; // aktuelles Log existiert: Logs pro Monat hochzaehlen
							breakit=0;  //wieder auf 0, ham ja gerade eins gefunden
							auswertung=true;
						}
													
					}	
				
					if( breakit > 2 ) 
						break; //direkt aus den 10ern raus
				}
			
				if( breakit > 2 )
					break;//direkt aus den 100ern raus	 
			}	
			if( auswertung )
			{
				cout << "."; //Pro geloggtem Tag ein * ausgeben
				tage[monat]++; // Ausgewertete Tage iterieren
			}
			breakit=0; //fuer den neuen Tag, breakit wieder auf 0 setzen
			auswertung=false;
		}
		
		if( monate[monat] > 0 )
		{
			cout << endl<< " --> "<<monate[monat]<< " Logs an " << tage[monat] << " Tagen gescannt" << endl; 
		}
		else 
		{
			cout << " keine Logs gefunden" << endl;
		}
	}
	cout <<endl;
	
	short taganzahl=0;
	for (short j=1;j<=12;j++)
	{
		taganzahl+=tage[j];
	}
	cout << " -> Es wurden "<<anzahlcheater<<" Secure-Violations ("<<verschcheater<<" versch. Cheater) in " <<logs<< " Logfiles gefunden ("<<taganzahl<<" Tage insgesamt)"<< endl;
	gesamttage+=taganzahl;
}

void help_out(char aufruf[])
{
	cout<<endl<<"Usage: "<<aufruf<<" <optionen>"<<endl
	    <<"Optionen:"<<endl
	    <<"         "<<"-help | --help            : "<<"gibt diese Hilfe aus"<<endl
	    <<"         "<<"-debug                    : "<<"schaltet Debugmode an"<<endl
	    <<"         "<<"-nostats                  : "<<"schaltet Statistik aus"<<endl
	    <<"         "<<"-htpfad <pfad>            : "<<"Htmlpfad"<<endl
	    <<"         "<<"-httitel <titel>          : "<<"Htmltitel"<<endl
	    <<"         "<<"-hthgfarbe <htmlfarbwert> : "<<"Htmlhgfarbe"<<endl
	    <<"         "<<"-htsfarbe <htmlfargwert>  : "<<"Htmlschriftfarbe"<<endl
	    <<"         "<<"-tfarbe <htmlfarbwert>    : "<<"Tabellenfarbe"<<endl
	    <<"         "<<"-thgfarbe <htmlfarbwert>  : "<<"Tabellenhgfarbe"<<endl
	    <<"         "<<"-tstaerke <wert>          : "<<"Tabellenstaerke"<<endl
	    <<"         "<<"-nfett                    : "<<"Schrift nicht fett"<<endl
	    <<"         "<<"-sgroesse <wert>          : "<<"Schriftgroesse"<<endl
	    <<"         "<<"-tops <text>              : "<<"Topschriftgroesse"<<endl
	    <<"         "<<"-lfarbe <htmlfarbwert>    : "<<"Linkfarbe"<<endl
	    <<"         "<<"-serverip <ip>            : "<<"Serverip"<<endl
	    <<"         "<<"-servername <text>        : "<<"Servername"<<endl<<endl;
}


void printcfg()
{
	cout <<endl<<"-------------Configwerte----------------"<<endl;
	cout <<" -> Htmlpfad : "<<pcfg->htmlpfad<<endl;
	cout <<" -> Htmltitel : "<<pcfg->htmltitel<<endl;
	cout <<" -> Htmlfarbe : "<<pcfg->htmlhgfarbe<<endl;
	cout <<" -> Htmlschriftfarbe : "<<pcfg->htmlschriftfarbe<<endl;
	cout <<" -> Tabellenfarbe : "<<pcfg->tabellenfarbe<<endl;
	cout <<" -> Tabellenhgfarbe : "<<pcfg->tabellenhgfarbe<<endl;
	cout <<" -> Tabellenstaerke : "<<pcfg->tabellenstaerke<<endl;
	cout <<" -> Schrift fett: "<<pcfg->schriftfett<<endl;
	cout <<" -> Schriftgroesse : "<<pcfg->schriftgroesse<<endl;
	cout <<" -> Topschriftgroesse : "<<pcfg->topschrift<<endl;
	cout <<" -> Linkfarbe : "<<pcfg->linkfarbe<<endl;
	cout <<" -> Serverip : "<<pcfg->serverip<<endl;
	cout <<" -> Servername : "<<pcfg->servername<<endl;
	cout <<" -> Statistik : "<<pcfg->statistik<<endl;
	cout <<" -> Debugmode : "<<pcfg->debug<<endl;
	cout <<endl<<endl;	
}
	   
void main(short argc, char *argv[])
{ 
	short i;
	pcfg->debug=false;  //Standardmode ist Non-Debug Mode	
	pcfg->statistik=true;

	for( i=1; i <= 12; i++) //Die Stats mal mit 0 initialisieren
	{
		monate[i]=0;
		tage[i]=0; 
	}
	
	if(argc > 1)  //Hier schonmal nach help und debug testen, WICHTIG
	{
	    for(i=1; i<argc; i++)
	    {
		if((strncmp( argv[i], "-help", 4)==0) || 
		   (strncmp( argv[i], "--help", 5)==0) ||
		   (strncmp( argv[i], "/h", 2)==0))
		{
			help_out(argv[0]);
			exit (0); //Nach --help -> Programmabbruch
		}
		
		else if(strncmp( argv[i], "-debug", 6)==0)
		{    	
			pcfg->debug=true;
		}
	    }
	}
	
	cout <<endl;
	cout <<" +*************************************+ "<<endl;
	cout <<" ***     CheaterGrep by MUff[99]     *** "<<endl;
	cout <<" ***      Version "<<s_version<<"  "<<s_datum<<"      *** "<<endl;
	cout <<" ***      Offizielle Homepage @      *** "<<endl;
	cout <<" ***  alderaan.knatterton.de/cgrep/  *** "<<endl;
	cout <<" +*************************************+ "<<endl;
	cout <<endl<<endl;
	
    	ifstream cfgtest("../cgconfig.txt");  //nach cfgfile checken
	if(cfgtest)
	{	
		cout <<" Config file gefunden, lade ..."<<endl;
		loadvalues();
		cout <<endl<<endl;
		
	if(argc > 1)           // Commandlineparameter, weitere Optionen durch if-abfragen einfuegen
	{
	    for(i=1; i<argc; i++)
	    {
	    	if (pcfg->debug) cout << " Commanduebergabe : "<<argv[i]<<endl;
		
		if(strncmp( argv[i], "-htpfad", 6)==0)
		{
			htmlexist=true;
			pcfg->htmlpfad=argv[++i];
			if (pcfg->debug) cout <<" -DEBUG- Commandaufruf : "<<argv[i]<< " Wert : "<<argv[++i]<<endl;
		}
		else if(strncmp( argv[i], "-httitel", 7)==0)
		{
			pcfg->htmltitel=argv[++i];
			if (pcfg->debug) cout <<" -DEBUG- Commandaufruf : "<<argv[i]<< " Wert : "<<argv[++i]<<endl;
		}
		else if(strncmp( argv[i], "-hthgfarbe", 9)==0)
		{
			pcfg->htmlhgfarbe=argv[++i];
			if (pcfg->debug) cout <<" -DEBUG- Commandaufruf : "<<argv[i]<< " Wert : "<<argv[++i]<<endl;
		}
		else if(strncmp( argv[i], "-htsfarbe", 7)==0)
		{
			pcfg->htmlschriftfarbe=argv[++i];
			if (pcfg->debug) cout <<" -DEBUG- Commandaufruf : "<<argv[i]<< " Wert : "<<argv[++i]<<endl;
		}
		else if(strncmp( argv[i], "-tfarbe", 6)==0)
		{	
			pcfg->tabellenfarbe=argv[++i];
			if (pcfg->debug) cout <<" -DEBUG- Commandaufruf : "<<argv[i]<< " Wert : "<<argv[++i]<<endl;
		}
		else if(strncmp( argv[i], "-thgfarbe", 8)==0)
		{
			pcfg->tabellenhgfarbe=argv[++i];
			if (pcfg->debug) cout <<" -DEBUG- Commandaufruf : "<<argv[i]<< " Wert : "<<argv[++i]<<endl;
		}
		else if(strncmp( argv[i], "-tstaerke", 8)==0)
		{	
			pcfg->tabellenstaerke=argv[++i];
			if (pcfg->debug) cout <<" -DEBUG- Commandaufruf : "<<argv[i]<< " Wert : "<<argv[++i]<<endl;

		}
		else if(strncmp( argv[i], "-nfett", 5)==0)
		{
			pcfg->schriftfett=false;
			if (pcfg->debug) cout <<" -DEBUG- Commandaufruf : "<<argv[i]<< " Wert : "<<argv[++i]<<endl;
		}
		else if(strncmp( argv[i], "-sgroesse", 7)==0)
		{
			pcfg->schriftgroesse=argv[++i];
			if (pcfg->debug) cout <<" -DEBUG- Commandaufruf : "<<argv[i]<< " Wert : "<<argv[++i]<<endl;
		}
		else if(strncmp( argv[i], "-tops", 4)==0)
		{	
			pcfg->topschrift=argv[++i];
			if (pcfg->debug) cout <<" -DEBUG- Commandaufruf : "<<argv[i]<< " Wert : "<<argv[++i]<<endl;
		}
		else if(strncmp( argv[i], "-lfarbe", 6)==0)
		{
			pcfg->linkfarbe=argv[++i];
			if (pcfg->debug) cout <<" -DEBUG- Commandaufruf : "<<argv[i]<< " Wert : "<<argv[++i]<<endl;
		}
		else if(strncmp( argv[i], "-serverip", 8)==0)
		{
			pcfg->serverip=argv[++i];
			if (pcfg->debug) cout <<" -DEBUG- Commandaufruf : "<<argv[i]<< " Wert : "<<argv[++i]<<endl;
		}
		else if(strncmp( argv[i], "-servername", 10)==0)
		{
			pcfg->servername=argv[++i];
			if (pcfg->debug) cout <<" -DEBUG- Commandaufruf : "<<argv[i]<< " Wert : "<<argv[++i]<<endl;
		}
		else if(strncmp( argv[i], "-nostats", 9)==0)
		{	
			pcfg->statistik=false;
			if (pcfg->debug) cout <<" -DEBUG- Commandaufruf : "<<argv[i]<< " Wert : "<<argv[++i]<<endl;
		}
	    }
	}	
		printcfg();  //DIE Werte werden jetzt genommen (ob von Commandline oder config)
		cout <<endl;
		logcheck();
		if (htmlexist==true) //nur falles es nen korrekten Pfad in der config gibt
		{
			cout <<" -> HTML Copy aktiviert"<<endl<<endl;
			htmlcopy();
			cout <<" -> Erstelle HTM-Datei...";
			htmfile();
			cout <<"done!"<<endl;
		}
	}
	else {cout <<" -> Keine Config file gefunden, bitte anlegen (siehe readme.txt)"<<endl; exit (1);}
	cfgtest.close();
	if(pcfg->statistik==true) statistik();
	cout <<endl<<" -> Erstelle Ban-Datei...";
	banfile();
	cout <<"done!"<<endl<<endl;
} //Ende Main